vals = 0:1:255;
response = -2*(vals.*vals)/(255*255)+2*(vals/255)+0.5;
for k=1:65
    k
    file = ['data/original/' num2str(k) '.png'];
    im = uint8(rgb2gray(imread(file)));
    [m n] = size(im);
    %thresh=mean(mean(im(:,:)));
    %im_thresh =zeros(m,n);
    %for i=1:m
    %    for j=1:n
    %        if im(i,j)>thresh
    %            im_thresh(i,j) = im(i,j);
    %        end
    %    end
    %end
    %im_thresh=uint8(im_thresh);
    %radius = floor(0.1*(m+n));
    
    %simple dilated-blurred brightness maps
    radius=10;
    se = strel('ball',radius,radius);
    res = imdilate(im,se);
    res1=imfilter(res,fspecial('gaussian',[5 5],2),'same');
    %res = res./max(max(res));
    imwrite(im, ['data/features/f_1_' num2str(k) '.png']);
    imwrite(res1, ['data/features/f_2_' num2str(k) '.png']);
    
    %response-modified brightness maps
    res2 = zeros(m,n);
     for i=1:m
         for j=1:n
             res2(i,j) = im(i,j)*response(im(i,j)+1);
         end
     end
     res2 = uint8(res2);
     res3 = imfilter(imdilate(res2,se),fspecial('gaussian',[5 5],2),'same');
     imwrite(res2, ['data/features/f_3_' num2str(k) '.png']);
     imwrite(res3, ['data/features/f_4_' num2str(k) '.png']);
end