function [adj] = create_adj(dimx,dimy)
    adj = sparse(dimx*dimy, dimx*dimy);
    for n=1:dimx*dimy
        if mod(n,dimy)==0
            i=(n/dimy);
        else
            i = 1+floor(n/dimy);
        end
        j = n-(i-1)*dimy;
        if i==1
            if j==1
                adj(n,n+1) = 1;
                adj(n,n+dimy) = 1;
            end
            if j==dimy
                adj(n,n-1) = 1;
                adj(n,n+dimy) = 1;
            end
            if j>1 && j<dimy
                adj(n,n-1) = 1;
                adj(n,n+1) = 1;
                adj(n,n+dimy) = 1;
            end
        end
        
        if i==dimx
            if j==1
                adj(n,n+1) = 1;
                adj(n,n-dimy) = 1;
            end
            if j==dimy
                adj(n,n-1) = 1;
                adj(n,n-dimy) = 1;
            end
            if j>1 && j<dimy
                adj(n,n-1) = 1;
                adj(n,n+1) = 1;
                adj(n,n-dimy) = 1;
            end
        end
        
        if j==1
            if i==1
                adj(n,n+1) = 1;
                adj(n,n+dimy) = 1;
            end
            if i==dimx
                adj(n,n+1) = 1;
                adj(n,n-dimy) = 1;
            end
            if i>1 && i<dimx
                adj(n,n-dimy) = 1;
                adj(n,n+1) = 1;
                adj(n,n+dimy) = 1;
            end
        end
        
        if j==dimy
            if i==1
                adj(n,n-1) = 1;
                adj(n,n+dimy) = 1;
            end
            if i==dimx
                adj(n,n-1) = 1;
                adj(n,n-dimy) = 1;
            end
            if i>1 && i<dimx
                adj(n,n-dimy) = 1;
                adj(n,n-1) = 1;
                adj(n,n+dimy) = 1;
            end
        end      
        %non-boundary cases
        if i>1 && i<dimx && j>1 && j<dimy
            adj(n,n-1) = 1;
            adj(n,n+1) = 1;
            adj(n,n-dimy) = 1;
            adj(n,n+dimy) = 1;
        end
        %adj = adj+adj';
    end
end