%%mutli-scale contrast

for k=1:65
    k
    file = ['data/original/' num2str(k) '.png'];
    im = uint8(imread(file));
    [m n p] = size(im);
    im = rgb2hsv(im);
    
    %extract saturation map
    res = zeros(m,n);
    res(:,:) = im(:,:,2).*im(:,:,3); 
    res = uint8(255*res);
    
    %dilate result
    radius = 10;
    se = strel('ball',radius,radius);
    res1 = imfilter(imdilate(res,se),fspecial('gaussian',[5 5],2),'same');
   
    res1 = uint8(res1);
    imwrite(res,['data/features/f_7_' num2str(k) '.png']);
    imwrite(res1,['data/features/f_8_' num2str(k) '.png']);

end